## solvespace 2.3.0+git1213-2b9ffd1

=== debian/changelog ===
solvespace (2.3.0+git1213-2b9ffd1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 14 Jul 2018 16:33:58 -0700

solvespace (2.3.0+git1213-2b9ffd1-1ppa1~artful1) artful; urgency=medium

  * Automated backport upload; no source changes.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sat, 12 May 2018 18:43:19 +0300

solvespace (2.3.0+git1213-2b9ffd1-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 2b9ffd15424eb95a21db6e6ca35339b3d9372b2e
  * Date: 1525966315
  * git changelog:
  *  2b9ffd1 - Fix handling of relative paths with no directory in
    solvespace-cli.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sat, 12 May 2018 18:43:18 +0300

solvespace (2.3.0+git1212-c6fc012-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: c6fc0125a21aa27f89ab6e0bb16037f04bc39fd4
  * Date: 1513536278
  * git changelog:
  *  c6fc012 - README: add OpenBSD instructions.
  *  3d7e9f5 - Provide correct arguments to inflateInit2.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Tue, 19 Dec 2017 22:21:40 +0300

solvespace (2.3.0+git1210-13695be-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 13695be03a8e78ccc24d0179a3ff243d8bd148d6
  * Date: 1509946849
  * git changelog:
  *  13695be - CMake: update required version to 3.2.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Thu, 16 Nov 2017 12:11:38 +0300

solvespace (2.3.0+git1209-16540b1-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 16540b1b2c540a4b44500ac02aaa4493bccfba7e
  * Date: 1502195260
  * git changelog:
  *  16540b1 - Update libdxfrw.
  *  a10db16 - Fix dash-dash-dot line style.
  *  afe2279 - Elaborate build instructions in README.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Thu, 10 Aug 2017 22:03:18 +0300

solvespace (2.3.0+git1206-49c64f7-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 49c64f7f1520160ad4584ca55382055f3111d4ac
  * Date: 1500781960
  * git changelog:
  *  49c64f7 - CMake, macOS: create bundle directory explicitly.
  *  32120ea - CONTRIBUTING, README: add XCode instructions.
  *  0b79dc2 - Update macOS build section in README.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 28 Jul 2017 01:36:44 +0300

solvespace (2.3.0+git1203-33b6e51-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 33b6e5173724ebb207c4d8450a561448b2e07e5d
  * Date: 1494193553
  * git changelog:
  *  33b6e51 - Locale LCID is a hex number, not a decimal.
  *  90e9fc7 - CONTRIBUTING: add a section on translations.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sun, 14 May 2017 13:23:13 +0300

solvespace (2.3.0+git1201-280d5b9-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 280d5b902f95fda3727d0d12a2653c38c9675049
  * Date: 1493248074
  * git changelog:
  *  280d5b9 - TTF: avoid crashes on fonts without U+0041 LATIN CAPITAL
    LETTER A.
  *  5078907 - I18n: regenerate.
  *  ab7cdea - I18n: add a ru_RU translation.
  *  5408f73 - Fix a crash creating a group from a non-reference
    workplane.
  *  fe622a1 - Add a test for workplane request.
  *  85b4b25 - Fix a crash changing g->meshCombine when g-
    >type!=EXTRUDE.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 28 Apr 2017 10:22:52 +0300

solvespace (2.3.0+git1194-e5259d7-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: e5259d7a3eef2662b98c27853b0eda506ab62416
  * Date: 1491972683
  * git changelog:
  *  e5259d7 - Swap arc endpoints when pasting transformed with negative
    scale.
  *  5d67b42 - CMake: don't have multiple rules generating same targets.
  *  287bd98 - Fix copying and pasting image requests.
  *  99f6ea3 - Add an option to display areas of closed contours.
  *  c0b6eaa - Fix automatic marking of constraints as reference.
  *  43dc162 - Rewrite equation for pt-on-circle to avoid negative
    diameter.
  *  8fd11f4 - Fix forcing NURBS to mesh in a step group when the flag
    is inherited.
  *  ecb6550 - Change mentions of OpenGL 2 to OpenGL 3.
  *  7eb6574 - Rename TextWindow::CHAR_WIDTH to CHAR_WIDTH_.
  *  b0ea9d8 - Allow suppressing solid model of extrude and lathe
    groups.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 14 Apr 2017 09:51:21 +0300

solvespace (2.3.0+git1184-6337bbb-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: 6337bbbcd6e753427bed47d7e9f43d9836e4347b
  * Date: 1490209980
  * git changelog:
  *  6337bbb - Fix a missing semicolon.
  *  aaa9c6d - Fix a texture memory leak.
  *  827f54f - GTK: ensure the editor always uses contrasting colors.
  *  911c67b - Fix benchmark harness after e2e74762.
  *  acc25ec - Fix toolbar height after 5744d1d5.
  *  ca2aad7 - Remove the "style → background image" feature.
  *  5744d1d - Implement an image request.
  *  e2e7476 - Rework path and file operations to be more robust.
  *  335c217 - Collect together and rigorously test all our ad-hoc path
    functions.
  *  60f85f5 - Win32: fix invalid accelerator labels.
  *  7e2b1b1 - Add a test for the link group.
  *  15f3490 - Make CLI usage text more readable.
  *  27b59f6 - Fix type conversion warnings.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sat, 25 Mar 2017 10:59:52 +0300

solvespace (2.3.0+git1171-dbf6663-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/solvespace/solvespace.git
  * Branch: master
  * Commit: dbf66639aa17c77d105072ab689bcf657f306636
  * Date: 1489001145
  * git changelog:

