=== debian/control ===
Source: solvespace
Section: graphics
Priority: optional
Maintainer: Alexander Pozdnyakov <almipo@mail.ru>
Build-Depends: debhelper (>= 9), cmake, libpng-dev, zlib1g-dev, libjson-c-dev,
    libfontconfig1-dev, libgtkmm-3.0-dev (>= 3.22), libpangomm-1.4-dev,
    libgl-dev, libglu-dev, libglew-dev, libspnav-dev, libpng-dev, libfreetype6-dev
Standards-Version: 3.9.8
Homepage: http://solvespace.com

Package: solvespace
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: parametric 2d/3d CAD
 SolveSpace is a parametric 2d/3d CAD program. Applications include:
 .
  * modeling 3d parts — draw with extrudes, revolves, and Boolean
    (union / difference) operations;
  * modeling 2d parts — draw the part as a single section, and export DXF,
    PDF, SVG; use 3d assembly to verify fit;
  * 3d-printed parts — export the STL or other triangle mesh expected by
    most 3d printers;
  * preparing CAM data — export 2d vector art for a waterjet machine or
    laser cutter; or generate STEP or STL, for import into third-party
    CAM software for machining;
  * mechanism design — use the constraint solver to simulate planar or
    spatial linkages, with pin, ball, or slide joints;
  * plane and solid geometry — replace hand-solved trigonometry and
    spreadsheets with a live dimensioned drawing.

Package: solvespace-dbg
Architecture: any
Section: debug
Priority: extra
Depends: solvespace (= ${binary:Version}), ${misc:Depends}
Description: parametric 2d/3d CAD (debugging files)
 SolveSpace is a parametric 2d/3d CAD.
 .
 This package contains the debugging symbols for solvespace.

Package: libslvs1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SolveSpace geometric kernel
 SolveSpace is a parametric 2d/3d CAD. libslvs contains the geometric
 kernel of SolveSpace, built as a library.

Package: libslvs1-dev
Section: libs
Architecture: any
Multi-Arch: same
Depends: libslvs1 (= ${binary:Version}), ${misc:Depends}
Description: SolveSpace geometric kernel (development files)
 SolveSpace is a parametric 2d/3d CAD. libslvs contains the geometric
 kernel of SolveSpace, built as a library.
 .
 This package includes development files for libslvs.

Package: libslvs1-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libslvs1 (= ${binary:Version}), ${misc:Depends}
Description: SolveSpace geometric kernel (debugging files)
 SolveSpace is a parametric 2d/3d CAD. libslvs contains the geometric
 kernel of SolveSpace, built as a library.
 .
 This package contains the debugging symbols for libslvs1.
